﻿Class MainWindow 

    Dim DoubleCommand As RoutedUICommand = New RoutedUICommand()

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        Dim OpenBinding As CommandBinding = New CommandBinding(
                                            ApplicationCommands.Open, AddressOf OpenHandler)
        Dim DoubleBinding As CommandBinding = New CommandBinding(
                                              DoubleCommand, AddressOf DoubleHandler)

        ApplicationCommands.Open.InputGestures.Clear()

        DoubleCommand.InputGestures.Add(New KeyGesture(Key.D,
                                                       ModifierKeys.Control))

        Dim UmeKeyBinding As KeyBinding = New KeyBinding(
                                          ApplicationCommands.Open, Key.U, ModifierKeys.Control)
        Dim CherryKeyBinding As KeyBinding = New KeyBinding(
                                             ApplicationCommands.Open, Key.C, ModifierKeys.Control)
        Dim AzaleaKeyBinding As KeyBinding = New KeyBinding(
                                             ApplicationCommands.Open, Key.A, ModifierKeys.Control)
        Dim HydrangeaKeyBinding As KeyBinding = New KeyBinding(
                                                ApplicationCommands.Open, Key.H, ModifierKeys.Control)

        UmeKeyBinding.CommandParameter =
            UmeMenuItem.CommandParameter
        CherryKeyBinding.CommandParameter =
            CherryMenuItem.CommandParameter
        AzaleaKeyBinding.CommandParameter =
            AzaleaMenuItem.CommandParameter
        HydrangeaKeyBinding.CommandParameter =
            HydrangeaMenuItem.CommandParameter

        DoubleMenuItem.Command = DoubleCommand

        Me.CommandBindings.Add(OpenBinding)
        Me.CommandBindings.Add(DoubleBinding)

        Me.InputBindings.Add(UmeKeyBinding)
        Me.InputBindings.Add(CherryKeyBinding)
        Me.InputBindings.Add(AzaleaKeyBinding)
        Me.InputBindings.Add(HydrangeaKeyBinding)

    End Sub

    Private Sub OpenHandler(ByVal sender As System.Object, ByVal e As ExecutedRoutedEventArgs)

        Image1.Source = New BitmapImage(New Uri(e.Parameter.ToString(),
                                                UriKind.Relative))
        DoubleImage()

    End Sub

    Private Sub DoubleHandler(ByVal sender As System.Object, ByVal e As ExecutedRoutedEventArgs)

        DoubleMenuItem.IsChecked = Not DoubleMenuItem.IsChecked
        DoubleImage()

    End Sub

    Private Sub DoubleImage()

        Image2.Source = If(DoubleMenuItem.IsChecked,
                           Image1.Source, Nothing)

    End Sub
End Class
