﻿Imports System.IO, System.ComponentModel
Class MainWindow

    Dim MyBackgroundWorker As BackgroundWorker

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        MyBackgroundWorker = New BackgroundWorker()
        AddHandler MyBackgroundWorker.DoWork,
            AddressOf BackgroundWorker_DoWork
        AddHandler MyBackgroundWorker.RunWorkerCompleted,
            AddressOf BackgroundWorker_RunWorkerCompleted
        AddHandler MyBackgroundWorker.ProgressChanged,
            AddressOf BackgroundWorker_ProgressChanged
        MyBackgroundWorker.WorkerReportsProgress = True
        MyBackgroundWorker.WorkerSupportsCancellation = True

    End Sub

    Private Sub BackgroundWorker_DoWork(ByVal sender As Object, ByVal e As DoWorkEventArgs)

        For i As Integer = 1 To 5
            If WriteFile(Path.Combine(Path.GetDirectoryName(
                                      Application.ResourceAssembly.Location),
                                  "Alphabet" & i), sender) Then
                e.Cancel = True
                Exit For
            End If
        Next

    End Sub

    Private Sub BackgroundWorker_RunWorkerCompleted(ByVal sender As Object, ByVal e As RunWorkerCompletedEventArgs)

        If e.Cancelled Then
            Label1.Content = "処理がキャンセルされました"
        ElseIf e.Error IsNot Nothing Then
            MessageBox.Show(e.Error.Message, Me.Title,
                            MessageBoxButton.OK, MessageBoxImage.Error)
        End If
        Button1.IsEnabled = True

    End Sub

    Private Sub BackgroundWorker_ProgressChanged(ByVal sender As Object, ByVal e As ProgressChangedEventArgs)

        Label1.Content = e.UserState & "を処理中　" &
            e.ProgressPercentage & "% 完了"

    End Sub

    Function WriteFile(ByVal fn As String, ByVal Worker As BackgroundWorker) As Boolean

        Dim r As Random = New Random()
        Dim sw As StreamWriter = New StreamWriter(fn)
        Dim CancelState As Boolean = False

        Dim s As String =
            "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
        For i As Integer = 1 To 104857600
            If i Mod 1048576 = 0 Then
                Worker.ReportProgress(i / 1048576,
                                      Path.GetFileName(fn))
            End If
            If Worker.CancellationPending Then
                CancelState = True
                Exit For
            End If
            sw.Write(s.Chars(r.Next(s.Length)))
        Next
        sw.Close()
        Return CancelState

    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click

        MyBackgroundWorker.RunWorkerAsync()
        Button1.IsEnabled = False

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button2.Click
        MyBackgroundWorker.CancelAsync()
    End Sub
End Class
