﻿Class MainWindow 

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click
        DrawGraph()
    End Sub

    Sub DrawGraph()

        Dim OuterRadius As Double = 75
        Dim InnerRadius As Double = 20

        Dim CenterX As Double = Canvas1.ActualWidth / 2
        Dim CenterY As Double = Canvas1.ActualHeight / 2

        Dim NumberList As List(Of Integer) = New List(Of Integer)()

        For i As Integer = 0 To ListBox1.Items.Count - 1
            NumberList.Add(CType(ListBox1.Items(i), ListBoxItem).Content)
        Next

        Dim FillBrushes As Brush() = New Brush() {
            Brushes.Red, Brushes.Orange, Brushes.Yellow,
            Brushes.LightGreen, Brushes.Lime,
            Brushes.LightSeaGreen, Brushes.LightCoral}
        Dim rx As Double = 3 / 2 * Math.PI

        Dim pt = Function(dr As Double, rr As Integer) As Point
                     Dim x As Double = Math.Cos(dr) * rr + CenterX
                     Dim y As Double = Math.Sin(dr) * rr + CenterY
                     Return New Point(x, y)
                 End Function

        Dim Total As Integer = 0
        For Each i As Integer In NumberList
            Total += i
        Next

        Canvas1.Children.Clear()
        For i As Integer = 0 To NumberList.Count - 1

            Dim DrawSweep As Double =
                NumberList(i) / Total * 2 * Math.PI

            Dim Pos As Point = pt(rx, OuterRadius)
            Dim Pis As Point = pt(rx, InnerRadius)
            Dim Poe As Point = pt(rx + DrawSweep, OuterRadius)
            Dim Pie As Point = pt(rx + DrawSweep, InnerRadius)

            rx += DrawSweep

            Dim Figure As PathFigure = New PathFigure() With
                                       {.StartPoint = Pos}
            Figure.Segments.Add(New ArcSegment(Poe,
                                               New Size(OuterRadius, OuterRadius), 0,
                                               DrawSweep > Math.PI, SweepDirection.Clockwise,
                                               True))
            Figure.Segments.Add(New LineSegment(Pie, True))
            Figure.Segments.Add(New ArcSegment(Pis,
                                               New Size(InnerRadius, InnerRadius), 0,
                                               DrawSweep > Math.PI,
                                               SweepDirection.Counterclockwise, True))

            Dim MyGeo As PathGeometry = New PathGeometry()
            MyGeo.Figures.Add(Figure)
            Dim MyPath As Path = New Path() With {.Data = MyGeo}
            MyPath.Fill = FillBrushes(i)
            Canvas1.Children.Add(MyPath)

        Next

    End Sub

    Private Sub AddButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles AddButton.Click

        Dim Number As Integer
        If ListBox1.Items.Count > 6 Then
            MessageBox.Show("数値が多すぎます")
        ElseIf Integer.TryParse(TextBox1.Text, Number) Then
            Dim Item As ListBoxItem = New ListBoxItem() With
                                      {.Content = TextBox1.Text}
            ListBox1.Items.Add(Item)
        Else
            MessageBox.Show("整数を入力してください")
        End If

    End Sub

    Private Sub DelButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles DelButton.Click

        If ListBox1.SelectedItem IsNot Nothing Then
            ListBox1.Items.Remove(ListBox1.SelectedItem)
        End If

    End Sub
End Class
